#include <iostream>
#include <vector>
using namespace std;

/*
4
0 1 2 3
3
0 1
0 2
0 3

3
3
0
*/

short bitovi[32];

// O(n * 32) = O(n)
void odredi_najveci_niz(vector<int>* b) {
    for(int i = 0; i < 32; i++) {
        bitovi[i] = 0;
    }
    for(int i = 0; i < b->size(); i++) {
        for(int j = 0; j < 32; j++) {
            bitovi[j] += b->at(i) & 1; b->at(i) >>= 1; 
        }
    }
    for(int i = 0; i < b->size(); i++) {
        for(int j = 0; j < 32; j++) {
            if(bitovi[j] > 0) {
                b->at(i) += 1 << j;
                bitovi[j]--;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, q, zbir = 0, t, k, x;
    vector<int> a;
    vector<int> b;
    scanf("%d", &n);
    a.resize(n);
    b.resize(n);
    for(int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
        b[i] = a[i];
    }
    
    // Formiranje leksikografski najveceg niza
    // brzina ~ O(C * n)
    odredi_najveci_niz(&b); // success!

    // O(q * n)
    scanf("%d", &q);
    for(int i = 0; i < q; i++) {
        scanf("%d %d", &t, &k);
        if(t == 1) {
            scanf("%d", &x);
            a[k-1] = x;
            
            // O(q * n) > limit
            for(int j = 0; j < n; j++) {
                b[j] = a[j];
            }
            odredi_najveci_niz(&b);
        }
        else { // t = 0
            printf("%d\n", b[k-1]);
        }
    }

    return 0;
}